import sys
import os
from PyQt5 import QtCore, QtGui, uic, QtQml, QtQuick
import subprocess
import pathlib
import threading
import json
rootdir = str(pathlib.Path(__file__).parent.resolve())
import numpy as np

QML6_IMPORT_PATH = 


global PROJECTDIR
global TEMP_DIR_BG
global LOAD_RELOAD_BG
global GLASS_BG
global BGSAMPLENAME
global PARAMETERS
global AVERAGE
PROJECTDIR = ""
TEMP_DIR_BG = None
LOAD_RELOAD_BG = None
GLASS_BG = None
BGSAMPLENAME = None
PARAMETERS = None
AVERAGE = None

def add_to_json(data,filename):
    with open(filename,"r+") as file:
        file_data = json.load(file)
        file_data["parameters"].append(data)
        file.seek(0)
        json.dump(file_data,file,indent = 4)

def change_json(data,filename):
    with open(filename,"r+") as file:
        file_data = json.load(file)
        params = file_data["parameters"][0]
        for i,param in enumerate(list(data.keys())):
            params[param] = data[param]
        file.seek(0)
        global PARAMETERS
        PARAMETERS = file_data
        json.dump(file_data,file,indent = 4)

class Helper(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        filename = url.toLocalFile()
        print(filename)
        
class SaveSettings(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        filename = url.toLocalFile()
        start_temp_bg = self.win.findChild(QtCore.QObject, 'textField44')
        start_temp_bg = start_temp_bg.property("text")
        reac_temp_bg = self.win.findChild(QtCore.QObject, 'textField45')
        reac_temp_bg = reac_temp_bg.property("text")
        start_temp_meas = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas = start_temp_meas.property("text")
        reac_temp_meas = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas = reac_temp_meas.property("text")
        Qmaxinst = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst = Qmaxinst.property("text")
        Qmin = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin = Qmin.property("text")
        Qmax = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax = Qmax.property("text")
        Rrange = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange = Rrange.property("text")
        rpoly = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly = rpoly.property("text")
        glass = self.win.findChild(QtCore.QObject, 'textField21')
        glass = glass.property("text")
        
        #Data output file
        data = np.array([['start_temp_bg','reac_temp_bg','start_temp_meas','reac_temp_meas','Qmaxinst','Qmax','Qmin','Rrange','rpoly','glass'],[start_temp_bg,reac_temp_bg,start_temp_meas,reac_temp_meas,Qmaxinst,Qmax,Qmin,Rrange,rpoly,glass]])
        # outfname = rootdir + "/" +  '.dat' #output directory and filename
        np.savetxt(filename, data.T,header = 'PDF Measurment processing params for FlyPDF', fmt='%s')

class LoadSettings(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        filename = url.toLocalFile()
        start_temp_bg,reac_temp_bg,start_temp_meas,reac_temp_meas,Qmaxinst,Qmax,Qmin,Rrange,rpoly,glass = np.loadtxt(filename,skiprows=1,dtype="str")
        start_temp_bg_obj = self.win.findChild(QtCore.QObject, 'slider30')
        start_temp_bg_obj.setProperty("value", start_temp_bg[1])
        reac_temp_bg_obj = self.win.findChild(QtCore.QObject, 'textField45')
        reac_temp_bg_obj.setProperty("text",reac_temp_bg[1])
        start_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas_obj.setProperty("text",start_temp_meas[1])
        reac_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas_obj.setProperty("text",reac_temp_meas[1])
        Qmaxinst_obj = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst_obj.setProperty("text",Qmaxinst[1])
        Qmin_obj = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin_obj.setProperty("text",Qmax[1])
        Qmax_obj = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax_obj.setProperty("text", Qmin[1])
        Rrange_obj = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange_obj.setProperty("text",Rrange[1])
        rpoly_obj = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly_obj.setProperty("text",rpoly[1])
        glass_obj = self.win.findChild(QtCore.QObject, 'textField21')
        glass_obj.setProperty("text",glass[1])

class NewProject(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global PROJECTDIR
        global PARAMETERS
        PROJECTDIR = url.toLocalFile()
        print(PROJECTDIR)
        if not os.path.exists(PROJECTDIR):
            os.makedirs(PROJECTDIR) 
        #data = np.array([['start_temp_bg','reac_temp_bg','start_temp_meas','reac_temp_meas','Qmaxinst','Qmax','Qmin','Rrange','rpoly','glass'],["20","150","20","150","30","25","0.01","30","0.9","0.0"]])
        PARAMETERS = { "parameters": [{
                'start_temp_bg': 20 ,
                'reac_temp_bg': 150,
                'start_temp_meas': 20,
                'reac_temp_meas': 150,
                'Qmaxinst': 30,
                'Qmax': 25,
                'Qmin': 0.01,
                'Rrange': 30,
                'rpoly': 0.9,
                'glass': 0.0
            },],   
        }
        with open(PROJECTDIR+"/project_params.json","w") as outfile:
            json.dump(PARAMETERS,outfile)
        #np.savetxt(PROJECTDIR+"/project_params.prm", data.T,header = 'PDF Measurment processing params for FlyPDF', fmt='%s')
        

class LoadProject(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win 
        
    @QtCore.pyqtSlot(QtCore.QUrl)
    def run(self,url):
        PROJECTDIR = url.toLocalFile()
        start_temp_bg,reac_temp_bg,start_temp_meas,reac_temp_meas,Qmaxinst,Qmax,Qmin,Rrange,rpoly,glass = np.loadtxt(PROJECTDIR+"/project_params.prm",skiprows=1,dtype="str")
        start_temp_bg_obj = self.win.findChild(QtCore.QObject, 'slider30')
        start_temp_bg_obj.setProperty("value", start_temp_bg[1])
        reac_temp_bg_obj = self.win.findChild(QtCore.QObject, 'textField45')
        reac_temp_bg_obj.setProperty("text",reac_temp_bg[1])
        start_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas_obj.setProperty("text",start_temp_meas[1])
        reac_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas_obj.setProperty("text",reac_temp_meas[1])
        Qmaxinst_obj = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst_obj.setProperty("text",Qmaxinst[1])
        Qmin_obj = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin_obj.setProperty("text",Qmax[1])
        Qmax_obj = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax_obj.setProperty("text", Qmin[1])
        Rrange_obj = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange_obj.setProperty("text",Rrange[1])
        rpoly_obj = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly_obj.setProperty("text",rpoly[1])
        glass_obj = self.win.findChild(QtCore.QObject, 'textField21')
        glass_obj.setProperty("text",glass[1])

class LoadBackground(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    
    def _runFunction(self):
        global PROJECTDIR
        global TEMP_DIR_BG
        global GLASS_BG
        global LOAD_RELOAD_BG
        global BGSAMPLENAME
        global AVERAGE
        print('New thread') 
        print(TEMP_DIR_BG)
        
        start_temp_bg = self.win.findChild(QtCore.QObject, 'textField44')
        start_temp_bg = start_temp_bg.property("text")
        reac_temp_bg = self.win.findChild(QtCore.QObject, 'textField45')
        reac_temp_bg = reac_temp_bg.property("text")
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.property("text")
        Qmaxinst = self.win.findChild(QtCore.QObject, 'textField49')
        Qmaxinst = Qmaxinst.property("text")
        BGSAMPLENAME = self.dirname.split("/")[-1]
        replacedata = {
                "sampleName": BGSAMPLENAME, 
                'BG_Qmaxinst': float(Qmaxinst),
                'BG_average': int(25),
                'start_temp_bg': int(start_temp_bg),
                'reac_temp_bg': int(reac_temp_bg), 
        }
        change_json(replacedata,PROJECTDIR+"/project_params.json")
        subprocess.run(["python", rootdir + "/scripts/PDF_generator_just_BG.py",'--mode=init',"--bgfile="+str(self.dirname), '--project='+str(PROJECTDIR),"--starttempbg="+str(start_temp_bg),"--reactempbg="+str(reac_temp_bg),"--average="+str(AVERAGE),"--qmaxinst="+str(Qmaxinst),"--tempdir="+str(TEMP_DIR_BG),"--reload="+str(LOAD_RELOAD_BG),"--bgglass="+str(GLASS_BG)])    

    
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        self.dirname = url.toLocalFile()
        
        thread = threading.Thread(target=self._runFunction)
        thread.start()
        
       
        
class LoadTemp(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global TEMP_DIR_BG
        TEMP_DIR_BG = url.toLocalFile()
        print(TEMP_DIR_BG)
        
class LoadReload(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global RELOAD_DIR
        RELOAD_DIR = url.toLocalFile()
        print(RELOAD_DIR)
       
class BGglass(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global GLASS_BG
        GLASS_BG = url.toLocalFile()
        print(GLASS_BG)
        
                           
def ensure_dir(dir_path):
    """
    Arguments
    ----------
    dir_path:   Path to directory   
    """ 
    if not os.path.exists(dir_path):
        os.makedirs(dir_path)

def save_project(outputPath):
    if outputPath != None:
        ensure_dir(outputPath)
    np.savetxt()
    
def load_project():
    np.savetxt()
  

   
    
def XRD_vs_Reference(win):
    subprocess.run(["python", rootdir + "/scripts/PDF_generator.py",'--mode=1D_slice',"--slice="],start_new_session=True)    

def XRD_1D_vs_time(win):
    subprocess.run(["python", rootdir + "/scripts/PDF_generator.py",'--mode=1D_vs_time',"--slice="],start_new_session=True)    

def XRD_2D_vs_time(win):
    subprocess.run(["python", rootdir + "/scripts/PDF_generator.py",'--mode=2D_vs_time'],start_new_session=True)    


def BG_XRD_Slice(win):
    def thread_function(win):
        slice = win.findChild(QtCore.QObject, 'textField43')
        slice = slice.property("text")
        subprocess.run(["python", rootdir + "/scripts/PDF_generator_just_BG.py",'--mode=1D_slice','--project='+str(PROJECTDIR),"--average="+str(AVERAGE),"--slice="+str(slice),"--samplename="+str(BGSAMPLENAME)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()

def BG_XRD_1D_vs_time(win):
    def thread_function(win):
        slice = win.findChild(QtCore.QObject, 'textField43')
        slice = slice.property("text")
        subprocess.run(["python", rootdir+ "/scripts/PDF_generator_just_BG.py",'--mode=1D_vs_time','--project='+str(PROJECTDIR),"--average="+str(AVERAGE),"--slice="+str(slice),"--samplename="+str(BGSAMPLENAME)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def BG_XRD_2D_vs_time(win):
    def thread_function(win):
        slice = win.findChild(QtCore.QObject, 'textField43')
        slice = slice.property("text")
        subprocess.run(["python", rootdir + "/scripts/PDF_generator_just_BG.py",'--mode=2D_vs_time','--project='+str(PROJECTDIR),"--average="+str(AVERAGE),"--samplename="+str(BGSAMPLENAME)],start_new_session=True)    

    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def PDF_1D_time_projected():
    subprocess.run(["python", "C:/Users/admin/Nextcloud/Python_Code/pymatgen.py",'--temperature1=woop'],start_new_session=True)

def PDF_1D_time_overlay():
    subprocess.run(["python", "C:/Users/admin/Nextcloud/Python_Code/pymatgen.py",'--temperature1=woop'],start_new_session=True)

def PDF_2D_time_map():
    subprocess.run(["python", "C:/Users/admin/Nextcloud/Python_Code/pymatgen.py",'--temperature1=woop'],start_new_session=True)




def main():

    app = QtGui.QGuiApplication(sys.argv)
    app.setWindowIcon(QtGui.QIcon(rootdir+"/asset_imports/FlyPDF_icon.ico"))

    engine = QtQml.QQmlApplicationEngine()
    helper = Helper()
    engine.rootContext().setContextProperty("helper", helper)
    
    #print(rootdir)
    #url = QtCore.QUrl.fromLocalFile("/home/groenetj/Documents/Scripts/FlyPDF/content/App.qml")
    engine.load("content/App.qml")
    
    win = engine.rootObjects()[0]
    
    #''''''''''''''''' ToolBar ''''''''''''''''''''''''''''''''''''''''''
    save_settings = SaveSettings(win)
    load_settings = LoadSettings(win)
    new_project = NewProject()
    load_project = LoadProject(win)
    load_temp_bg = LoadTemp()
    load_reload_bg = LoadReload()
    glass_bg = BGglass()
    
    load_background = LoadBackground(win) 
    
    engine.rootContext().setContextProperty("save_settings", save_settings)
    engine.rootContext().setContextProperty("load_settings", load_settings)
    engine.rootContext().setContextProperty("new_project", new_project)
    engine.rootContext().setContextProperty("load_project", load_project)
    engine.rootContext().setContextProperty("load_background", load_background)
    engine.rootContext().setContextProperty("load_bgtemp", load_temp_bg)
    engine.rootContext().setContextProperty("load_bgreload", load_reload_bg)
    engine.rootContext().setContextProperty("load_bgglass", glass_bg)
    
    
    #''''''''''''''''' Plot / Generate Buttons ''''''''''''''''''''''''''''''''''''''''''
    button = win.findChild(QtCore.QObject, '1D_vs_time')
    button.clicked.connect(lambda: BG_XRD_1D_vs_time(win)) # works too
    
    button = win.findChild(QtCore.QObject, '2D_vs_time')
    button.clicked.connect(lambda: BG_XRD_2D_vs_time(win)) # works too
    
    button = win.findChild(QtCore.QObject, '1D_slice')
    button.clicked.connect(lambda: BG_XRD_Slice(win)) # works too
    
    #''''''''''''''''' Load Buttons ''''''''''''''''''''''''''''''''''''''''''
    
    
    
    
    #''''''''''''''''' Init values ''''''''''''''''''''''''''''''''''''''''''
    textField44 = win.findChild(QtCore.QObject, 'textField44')
    textField44.setProperty("text", "20")
    textField45 = win.findChild(QtCore.QObject, 'textField45')
    textField45.setProperty("text", "150")
    textField18 = win.findChild(QtCore.QObject, 'textField18')
    textField18.setProperty("text", "20")
    textField19 = win.findChild(QtCore.QObject, 'textField19')
    textField19.setProperty("text", "150")
    textField11 = win.findChild(QtCore.QObject, 'textField11')
    textField11.setProperty("text", "30")
    textField13 = win.findChild(QtCore.QObject, 'textField13')
    textField13.setProperty("text", "25")
    textField14 = win.findChild(QtCore.QObject, 'textField14')
    textField14.setProperty("text", "30")
    textField15 = win.findChild(QtCore.QObject, 'textField15')
    textField15.setProperty("text", "0.9")

   
    def on_object_created(obj, objUrl):
        if obj is None and url == objUrl:
            QtCore.QCoreApplication.exit(-1)
            

    engine.objectCreated.connect(on_object_created, QtCore.Qt.ConnectionType.QueuedConnection)   
     
    sys.exit(app.exec())
    


if __name__ == "__main__":
    main()
    

