import sys
import os
import PyQt6
from PyQt6 import QtCore, QtQml #,QtGui 
import subprocess
import pathlib
import threading
import json
from python_scripts.PDF_generator_just_BG_class import LOADBG
from python_scripts.PDF_generator_classbase import LOADMEAS  
rootdir = str(pathlib.Path(__file__).parent.resolve())

global PROJECTDIR
global TEMP_DIR_BG
global TEMP_DIR_MEAS
global IMPORT_RELOAD_BG
global GLASS_MEAS
global GLASS_BG
global BGSAMPLENAME
global SAMPLENAME
global PARAMETERS
global AVERAGE
PROJECTDIR = ""
GLASS_MEAS = None
TEMP_DIR_BG = None
TEMP_DIR_MEAS = None
IMPORT_RELOAD_BG = None
GLASS_BG = None
BGSAMPLENAME = None
SAMPLENAME = None
PARAMETERS = None
AVERAGE = None


def add_to_json(data,filename):
    with open(filename,"r") as file:
        file_data = json.load(file)
        file_data["parameters"].append(data)
        file.seek(0)
    with open(filename,"w") as file:
        json.dump(file_data,file,indent = 4)

def change_json(data,filename):
    with open(filename,"r") as file:
        file_data = json.load(file)
        params = file_data["parameters"][0]
        for i,param in enumerate(list(data.keys())):
            params[param] = data[param]
        file.seek(0)
        global PARAMETERS
        PARAMETERS = file_data
    with open(filename,"w") as file:
        json.dump(file_data,file,indent = 4)

def open_json(filename):
    with open(filename,"r") as file:
        file_data = json.load(file)
        params = file_data["parameters"][0]
    return params

# class Helper(QtCore.QObject):
#     @QtCore.pyqtSlot(QtCore.QUrl)
#     def read_file(self,url):
#         filename = url.toLocalFile()
#         print(filename)
        
class SaveSettings(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        filename = url.toLocalFile()
        start_temp_meas = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas = start_temp_meas.property("text")
        reac_temp_meas = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas = reac_temp_meas.property("text")
        Qmaxinst = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst = Qmaxinst.property("text")
        Qmin = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin = Qmin.property("text")
        Qmax = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax = Qmax.property("text")
        Rrange = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange = Rrange.property("text")
        rpoly = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly = rpoly.property("text")
        glass_intens = self.win.findChild(QtCore.QObject, 'textField21')
        glass_intens = glass_intens.property("text")
        glass_bg_intens = self.win.findChild(QtCore.QObject, 'textField46')
        glass_bg_intens = glass_bg_intens.property("text")
        FactorMax = self.win.findChild(QtCore.QObject, 'textField24')
        FactorMax = FactorMax.property("text")
        Composition = self.win.findChild(QtCore.QObject, 'textField16')
        Composition = Composition.property("text")
        XRD_slice_bg = self.win.findChild(QtCore.QObject, 'textField43')
        XRD_slice_bg = XRD_slice_bg.property("text")
        XRD_slice_meas = self.win.findChild(QtCore.QObject, 'textField17')
        XRD_slice_meas = XRD_slice_meas.property("text")
        reference_pack = self.win.findChild(QtCore.QObject, 'textField20')
        reference_pack = reference_pack.property("text")
        scan_step = self.win.findChild(QtCore.QObject, 'textField31')
        scan_step = scan_step.property("text")
        start_scan_PDF = self.win.findChild(QtCore.QObject, 'textField35')
        start_scan_PDF = start_scan_PDF.property("text")
        end_scan_PDF = self.win.findChild(QtCore.QObject, 'textField36')
        end_scan_PDF = end_scan_PDF.property("text")
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.property("text")
        Qmaxinst_XRD = self.win.findChild(QtCore.QObject, 'textField49')
        Qmaxinst_XRD = Qmaxinst_XRD.property("text")
        temp_signatur = self.win.findChild(QtCore.QObject, 'temp')
        temp_signatur = temp_signatur.property("text")
        time_signatur = self.win.findChild(QtCore.QObject, 'time')
        time_signatur = time_signatur.property("text")
        endswith = self.win.findChild(QtCore.QObject, 'endswith')
        endswith = endswith.property("text")
        metadata_dir = self.win.findChild(QtCore.QObject, 'metadata_dir')
        metadata_dir = metadata_dir.property("text")
        
        PARAMETERS = { "parameters": [{
                'Qmaxinst_XRD': float(Qmaxinst_XRD),
                'average': int(AVERAGE),
                'start_temp_meas': float(start_temp_meas),
                'reac_temp_meas': float(reac_temp_meas),
                'Composition': Composition,
                'Qmaxinst': float(Qmaxinst),
                'Qmax': float(Qmax),
                'Qmin': float(Qmin),
                'Rrange': float(Rrange),
                'rpoly': float(rpoly),
                'glass_intens': float(glass_intens),
                'glass_bg_intens': float(glass_bg_intens),
                'FactorMax': float(FactorMax),
                'XRD_slice_bg': int(XRD_slice_bg),
                'XRD_slice_meas': int(XRD_slice_meas),
                'start_scan_PDF': int(start_scan_PDF),
                'end_scan_PDF': int(end_scan_PDF),   
                'scan_step': int(scan_step),
                'reference_pack': reference_pack,
                'temp_signatur': temp_signatur,
                'time_signatur': time_signatur,
                'endswith': endswith, 
                'metadata_dir': metadata_dir,
                }],
        }
        # if filename 
        with open(filename,"w") as outfile:
            json.dump(PARAMETERS,outfile)
        
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Params savet to file " + str(filename)) 
            
class LoadSettings(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global AVERAGE
        filename = url.toLocalFile() 
        params = open_json(filename)
        start_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas_obj.setProperty("text",params["start_temp_meas"])
        reac_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas_obj.setProperty("text",params["reac_temp_meas"])
        Qmaxinst_obj = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst_obj.setProperty("text",params["Qmaxinst"])
        Qmin_obj = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin_obj.setProperty("text",params["Qmin"])
        Qmax_obj = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax_obj.setProperty("text", params["Qmax"])
        Rrange_obj = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange_obj.setProperty("text",params["Rrange"])
        rpoly_obj = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly_obj.setProperty("text",params["rpoly"])
        glass_intens = self.win.findChild(QtCore.QObject, 'textField21')
        glass_intens.setProperty("text",params["glass_intens"])
        glass_bg_intens = self.win.findChild(QtCore.QObject, 'textField46')
        glass_bg_intens.setProperty("text",params["glass_bg_intens"])
        FactorMax = self.win.findChild(QtCore.QObject, 'textField24')
        FactorMax.setProperty("text",params["FactorMax"])
        Composition = self.win.findChild(QtCore.QObject, 'textField16')
        Composition.setProperty("text",params["Composition"])
        XRD_slice_bg = self.win.findChild(QtCore.QObject, 'textField43')
        XRD_slice_bg.setProperty("text",params["XRD_slice_bg"])
        XRD_slice_meas = self.win.findChild(QtCore.QObject, 'textField17')
        XRD_slice_meas.setProperty("text",params["XRD_slice_meas"])
        reference_pack = self.win.findChild(QtCore.QObject, 'textField20')
        reference_pack.setProperty("text",params["reference_pack"])
        scan_step = self.win.findChild(QtCore.QObject, 'textField31')
        scan_step.setProperty("text",params["scan_step"])
        start_scan_PDF = self.win.findChild(QtCore.QObject, 'textField35')
        start_scan_PDF.setProperty("text",params["start_scan_PDF"])
        end_scan_PDF = self.win.findChild(QtCore.QObject, 'textField36')
        end_scan_PDF.setProperty("text",params["end_scan_PDF"])
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.setProperty("text",params["average"])
        temp_signatur = self.win.findChild(QtCore.QObject, 'temp')
        temp_signatur = temp_signatur.setProperty("text",params['temp_signatur'])
        time_signatur = self.win.findChild(QtCore.QObject, 'time')
        time_signatur = time_signatur.setProperty("text",params['time_signatur'])
        endswith = self.win.findChild(QtCore.QObject, 'endswith')
        endswith = endswith.setProperty("text",params['endswith'])
        metadata_dir = self.win.findChild(QtCore.QObject, 'metadata_dir')
        metadata_dir = metadata_dir.setProperty("text",params['metadata_dir'])
        
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Params loaded from file " + str(filename)) 

class NewProject(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global PROJECTDIR
        global PARAMETERS
        PROJECTDIR = url.toLocalFile()
        print(PROJECTDIR)
        if not os.path.exists(PROJECTDIR):
            os.makedirs(PROJECTDIR) 
        PARAMETERS = { "parameters": [{
                    'average': 1,
                    'Composition': None,
                    'start_temp_meas': 20,
                    'reac_temp_meas': 150,
                    'Qmaxinst_XRD': 30,
                    'Qmaxinst': 30,
                    'Qmax': 25,
                    'Qmin': 0.01,
                    'Rrange': 30,
                    'rpoly': 0.9,
                    'glass_intens': 0.0,
                    'glass_bg_intens': 0.0,
                    'FactorMax': 1.3,
                    'Temp_dir_bg': None,
                    'XRD_slice_bg': None,
                    'XRD_slice_meas': None,
                    'start_scan_PDF': 1,
                    'end_scan_PDF': 10000,   
                    'scan_step': 1,
                    'reference_pack': None,
                    'sampleName_bg': BGSAMPLENAME, 
                    "sampleName": SAMPLENAME,
                    'temp_signatur': 'userComment2="Temperature=',
                    'time_signatur': 'dateString=',
                    'endswith': '.dat', 
                    'metadata_dir': None,
            },],   
        }
        with open(PROJECTDIR+"/project_params.json","w") as outfile:
            json.dump(PARAMETERS,outfile)
        
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: New Project created in directory " + str(PROJECTDIR)) 
        consol.setProperty("text", consol_text + "\nINFO: Project name " + str(PROJECTDIR.split("/")[-1]))

class LoadProject(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win 
        
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global BGSAMPLENAME
        global PROJECTDIR
        global AVERAGE
        PROJECTDIR = url.toLocalFile()
        print(PROJECTDIR)
        params = open_json(PROJECTDIR+"/project_params.json")
        start_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas_obj.setProperty("text",params["start_temp_meas"])
        reac_temp_meas_obj = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas_obj.setProperty("text",params["reac_temp_meas"])
        Qmaxinst_obj = self.win.findChild(QtCore.QObject, 'textField11')
        Qmaxinst_obj.setProperty("text",params["Qmaxinst"])
        Qmin_obj = self.win.findChild(QtCore.QObject, 'textField12')
        Qmin_obj.setProperty("text",params["Qmin"])
        Qmax_obj = self.win.findChild(QtCore.QObject, 'textField13')
        Qmax_obj.setProperty("text", params["Qmax"])
        Rrange_obj = self.win.findChild(QtCore.QObject, 'textField14')
        Rrange_obj.setProperty("text",params["Rrange"])
        rpoly_obj = self.win.findChild(QtCore.QObject, 'textField15')
        rpoly_obj.setProperty("text",params["rpoly"])
        glass_intens = self.win.findChild(QtCore.QObject, 'textField21')
        glass_intens.setProperty("text",params["glass_intens"])
        glass_bg_intens = self.win.findChild(QtCore.QObject, 'textField46')
        glass_bg_intens.setProperty("text",params["glass_bg_intens"])
        FactorMax = self.win.findChild(QtCore.QObject, 'textField24')
        FactorMax.setProperty("text",params["FactorMax"])
        Composition = self.win.findChild(QtCore.QObject, 'textField16')
        Composition.setProperty("text",params["Composition"])
        XRD_slice_bg = self.win.findChild(QtCore.QObject, 'textField43')
        XRD_slice_bg.setProperty("text",params["XRD_slice_bg"])
        XRD_slice_meas = self.win.findChild(QtCore.QObject, 'textField17')
        XRD_slice_meas.setProperty("text",params["XRD_slice_meas"])
        reference_pack = self.win.findChild(QtCore.QObject, 'textField20')
        reference_pack.setProperty("text",params["reference_pack"])
        scan_step = self.win.findChild(QtCore.QObject, 'textField31')
        scan_step.setProperty("text",params["scan_step"])
        start_scan_PDF = self.win.findChild(QtCore.QObject, 'textField35')
        start_scan_PDF.setProperty("text",params["start_scan_PDF"])
        end_scan_PDF = self.win.findChild(QtCore.QObject, 'textField36')
        end_scan_PDF.setProperty("text",params["end_scan_PDF"])
        BGSAMPLENAME = params["sampleName_bg"]
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.setProperty("text",params["average"])
        Qmaxinst_XRD = self.win.findChild(QtCore.QObject, 'textField49')
        Qmaxinst_XRD = Qmaxinst_XRD.setProperty("text",params["Qmaxinst_XRD"])
        FactorMax = self.win.findChild(QtCore.QObject, 'textField24')
        FactorMax = FactorMax.setProperty("text",params["FactorMax"])
        temp_signatur = self.win.findChild(QtCore.QObject, 'temp')
        temp_signatur = temp_signatur.setProperty("text",params['temp_signatur'])
        time_signatur = self.win.findChild(QtCore.QObject, 'time')
        time_signatur = time_signatur.setProperty("text",params['time_signatur'])
        endswith = self.win.findChild(QtCore.QObject, 'endswith')
        endswith = endswith.setProperty("text",params['endswith'])
        metadata_dir = self.win.findChild(QtCore.QObject, 'metadata_dir')
        metadata_dir = metadata_dir.setProperty("text",params['metadata_dir'])
        
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Project loaded from directory " + str(PROJECTDIR)) 
        consol.setProperty("text", consol_text + "\nINFO: Project name " + str(PROJECTDIR.split("/")[-1]))

class LoadBackground(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
        
    def _runFunction(self):
        global PROJECTDIR
        global TEMP_DIR_BG
        global GLASS_BG
        global IMPORT_RELOAD_BG
        global BGSAMPLENAME
        global AVERAGE
        print('New thread') 
        print(TEMP_DIR_BG)
        
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.property("text")
        Qmaxinst_XRD = self.win.findChild(QtCore.QObject, 'textField49')
        Qmaxinst_XRD = Qmaxinst_XRD.property("text")
        BGSAMPLENAME = self.dirname.split("/")[-1]
        glass_bg_intens = self.win.findChild(QtCore.QObject, 'textField46')
        glass_bg_intens = glass_bg_intens.property("text")
        temp_signatur = self.win.findChild(QtCore.QObject, 'temp')
        temp_signatur = temp_signatur.property("text")
        time_signatur = self.win.findChild(QtCore.QObject, 'time')
        time_signatur = time_signatur.property("text")
        endswith = self.win.findChild(QtCore.QObject, 'endswith')
        endswith = endswith.property("text")
        metadata_dir = self.win.findChild(QtCore.QObject, 'metadata_dir')
        metadata_dir = metadata_dir.property("text")
        
        replacedata = {
                "sampleName_bg": BGSAMPLENAME, 
                'Qmaxinst_XRD': float(Qmaxinst_XRD),
                'average': int(AVERAGE),
                'glass_bg_intens': float(glass_bg_intens),
                'glass_bg_file': GLASS_BG,
                'temp_signatur': temp_signatur,
                'time_signatur': time_signatur,
                'endswith': endswith, 
                'metadata_dir': metadata_dir,
        }
        change_json(replacedata,PROJECTDIR+"/project_params.json")
        bg_loaded = LOADBG(projectPath=PROJECTDIR,path=self.dirname,metadata_dir=metadata_dir,temp_signatur=temp_signatur,time_signatur=time_signatur, endswith=endswith, average=int(1),tempPath=TEMP_DIR_BG,sampleName=BGSAMPLENAME,bg_glass=GLASS_BG,empty_glass_int=float(glass_bg_intens),Qmaxinst_XRD=float(Qmaxinst_XRD),reload=IMPORT_RELOAD_BG)

        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Background files loaded") 
        
        BGwaitscreen = self.win.findChild(QtCore.QObject, 'BGwaitscreen')
        BGwaitscreen.setProperty("visible", False) 
        
        BGbutton = self.win.findChild(QtCore.QObject, 'loadBG')
        BGbutton.setProperty("enabled", True) 
        
    
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        self.dirname = url.toLocalFile()
        global BG_DIR 
        BG_DIR = self.dirname
        
        thread = threading.Thread(target=self._runFunction)
        thread.start()
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Loading of the background files started") 
        BGwaitscreen = self.win.findChild(QtCore.QObject, 'BGwaitscreen')
        BGwaitscreen.setProperty("visible", True) 
        BGbutton = self.win.findChild(QtCore.QObject, 'loadBG')
        BGbutton.setProperty("enabled", False) 
       
class LoadMeasurment(QtCore.QObject):
    def __init__(self,win) -> None:
        super().__init__()
        self.win = win
        
    def _runFunction(self):
        global PROJECTDIR
        global TEMP_DIR_MEAS
        global GLASS_MEAS
        global SAMPLENAME
        global AVERAGE
        print('New thread') 
        print(TEMP_DIR_MEAS)
        
        start_temp_meas = self.win.findChild(QtCore.QObject, 'textField18')
        start_temp_meas = start_temp_meas.property("text")
        reac_temp_meas = self.win.findChild(QtCore.QObject, 'textField19')
        reac_temp_meas = reac_temp_meas.property("text")
        average = self.win.findChild(QtCore.QObject, 'textField48')
        AVERAGE = average.property("text")
        Qmaxinst_XRD = self.win.findChild(QtCore.QObject, 'textField49')
        Qmaxinst_XRD = Qmaxinst_XRD.property("text")
        SAMPLENAME = self.dirname.split("/")[-1]
        glass_intens = self.win.findChild(QtCore.QObject, 'textField21')
        glass_intens = glass_intens.property("text")
        reference_pack = self.win.findChild(QtCore.QObject, 'textField20')
        reference_pack = reference_pack.property("text")
        XRD_Analyses = self.win.findChild(QtCore.QObject, 'XRD_Analyses')
        XRD_Analyses = XRD_Analyses.property("checked")
        filter_type1 = self.win.findChild(QtCore.QObject, 'filter_type1')
        filter_type1 = filter_type1.property("checked")
        filter_type2 = self.win.findChild(QtCore.QObject, 'filter_type2')
        filter_type2 = filter_type2.property("checked")
        filter_type3 = self.win.findChild(QtCore.QObject, 'filter_type3')
        filter_type3 = filter_type3.property("checked")
        filter_degree2 = self.win.findChild(QtCore.QObject, 'filter_degree2')
        filter_degree2 = filter_degree2.property("checked")
        filter_degree3 = self.win.findChild(QtCore.QObject, 'filter_degree3')
        filter_degree3 = filter_degree3.property("checked")
        filter_strength = self.win.findChild(QtCore.QObject, 'textField50')
        filter_strength = filter_strength.property("text")
        baseline_type1 = self.win.findChild(QtCore.QObject, 'baseline_type1')
        baseline_type1 = baseline_type1.property("checked")
        baseline_type2 = self.win.findChild(QtCore.QObject, 'baseline_type2')
        baseline_type2 = baseline_type2.property("checked")
        baseline_strength = self.win.findChild(QtCore.QObject, 'textField51')
        baseline_strength = baseline_strength.property("text")
        temp_signatur = self.win.findChild(QtCore.QObject, 'temp')
        temp_signatur = temp_signatur.property("text")
        time_signatur = self.win.findChild(QtCore.QObject, 'time')
        time_signatur = time_signatur.property("text")
        endswith = self.win.findChild(QtCore.QObject, 'endswith')
        endswith = endswith.property("text")
        metadata_dir = self.win.findChild(QtCore.QObject, 'metadata_dir')
        metadata_dir = metadata_dir.property("text")
        if filter_type1 == True:
            filter_type = None
        if filter_type2 == True:
            filter_type = "whittaker"
        if filter_type2 == True:
            filter_type = "savgol"
        if filter_degree2 == True:
            filter_degree = 2
        if filter_degree3 == True:
            filter_degree = 3
        if baseline_type1 == True:
            baseline_type = None
        if baseline_type2 == True:
            baseline_type = "SNIP"
        
        replacedata = {
                "sampleName": SAMPLENAME, 
                'Qmaxinst_XRD': float(Qmaxinst_XRD),
                'average': int(AVERAGE),
                'glass_intens': float(glass_intens),
                'start_temp_meas': int(start_temp_meas),
                'reac_temp_meas': int(reac_temp_meas), 
                'reference_pack': reference_pack,
                'glass_file': GLASS_MEAS,
                'filter_type': filter_type,
                'filter_strength': int(filter_strength),
                'baseline_type': baseline_type,
                'baseline_strength': int(baseline_strength),
                'filter_degree': int(filter_degree),
                'XRD_Analyses': XRD_Analyses,
                'temp_signatur': temp_signatur,
                'time_signatur': time_signatur,
                'endswith': endswith, 
                'metadata_dir': metadata_dir,
                
        }
        
        change_json(replacedata,PROJECTDIR+"/project_params.json")
        meas_loaded = LOADMEAS(projectPath=PROJECTDIR,path=self.dirname,metadata_dir=metadata_dir,temp_signatur=temp_signatur,time_signatur=time_signatur, endswith=endswith, ramp_start_temp=float(start_temp_meas),plato_start_temp=float(reac_temp_meas),average=int(1),tempPath=TEMP_DIR_MEAS,sampleName=SAMPLENAME, bg_sampleName=BGSAMPLENAME,glass=GLASS_MEAS,glass_intens=glass_intens,Qmaxinst_XRD=float(Qmaxinst_XRD),references=reference_pack)

        if XRD_Analyses == True:
            subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=XRD_Analyses","--project="+str(PROJECTDIR)],start_new_session=True)    
    
        
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Measurment loaded") 
        
        MEASwaitscreen = self.win.findChild(QtCore.QObject, 'MEASwaitscreen')
        MEASwaitscreen.setProperty("visible", False) 
        
        MEASbutton = self.win.findChild(QtCore.QObject, 'loadMEAS')
        MEASbutton.setProperty("enabled", True) 
        
    
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        self.dirname = url.toLocalFile() 
        global MEAS_DIR 
        MEAS_DIR = self.dirname
        
        thread = threading.Thread(target=self._runFunction)
        thread.start()
        consol = self.win.findChild(QtCore.QObject, 'consoleLog')
        consol_text = consol.property("text")
        consol.setProperty("text", consol_text + "\nINFO: Loading of the measurment started") 
        MEASwaitscreen = self.win.findChild(QtCore.QObject, 'MEASwaitscreen')
        MEASwaitscreen.setProperty("visible", True) 
        MEASbutton = self.win.findChild(QtCore.QObject, 'loadMEAS')
        MEASbutton.setProperty("enabled", False) 
       

class LoadTempMEAS(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global TEMP_DIR_MEAS
        TEMP_DIR_MEAS = url.toLocalFile()
        print(TEMP_DIR_MEAS)
        
class LoadTempBG(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global TEMP_DIR_BG
        TEMP_DIR_BG = url.toLocalFile()
        print(TEMP_DIR_BG)
        
class LoadReload(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global IMPORT_RELOAD_BG
        IMPORT_RELOAD_BG = url.toLocalFile()
        print(IMPORT_RELOAD_BG)
       
class BGglass(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global GLASS_BG
        GLASS_BG = url.toLocalFile()
        print(GLASS_BG)

class MEASglass(QtCore.QObject):
    @QtCore.pyqtSlot(QtCore.QUrl)
    def read_file(self,url):
        global GLASS_MEAS
        GLASS_MEAS = url.toLocalFile()
        print(GLASS_MEAS)

def param_update(win):
    global AVERAGE
    average = win.findChild(QtCore.QObject, 'textField48')
    AVERAGE = average.property("text")
    start_temp_meas = win.findChild(QtCore.QObject, 'textField18')
    start_temp_meas = start_temp_meas.property("text")
    reac_temp_meas = win.findChild(QtCore.QObject, 'textField19')
    reac_temp_meas = reac_temp_meas.property("text")
    Qmaxinst = win.findChild(QtCore.QObject, 'textField11')
    Qmaxinst = Qmaxinst.property("text")
    Qmin = win.findChild(QtCore.QObject, 'textField12')
    Qmin = Qmin.property("text")
    Qmax = win.findChild(QtCore.QObject, 'textField13')
    Qmax = Qmax.property("text")
    Rrange = win.findChild(QtCore.QObject, 'textField14')
    Rrange = Rrange.property("text")
    rpoly = win.findChild(QtCore.QObject, 'textField15')
    rpoly = rpoly.property("text")
    glass_intens = win.findChild(QtCore.QObject, 'textField21')
    glass_intens = glass_intens.property("text")
    glass_bg_intens = win.findChild(QtCore.QObject, 'textField46')
    glass_bg_intens = glass_bg_intens.property("text")
    FactorMax = win.findChild(QtCore.QObject, 'textField24')
    FactorMax = FactorMax.property("text")
    Composition = win.findChild(QtCore.QObject, 'textField16')
    Composition = Composition.property("text")
    slice_bg = win.findChild(QtCore.QObject, 'textField43')
    slice_bg = slice_bg.property("text")
    slice_meas = win.findChild(QtCore.QObject, 'textField17')
    slice_meas = slice_meas.property("text")
    reference_pack = win.findChild(QtCore.QObject, 'textField20')
    reference_pack = reference_pack.property("text")
    Qmaxinst_XRD = win.findChild(QtCore.QObject, 'textField49')
    Qmaxinst_XRD = Qmaxinst_XRD.property("text")
    scan_step = win.findChild(QtCore.QObject, 'textField31')
    scan_step = scan_step.property("text")
    pdf_set1 = win.findChild(QtCore.QObject, 'pdf_set1')
    pdf_set1 = pdf_set1.property("checked")
    pdf_set2 = win.findChild(QtCore.QObject, 'pdf_set2')
    pdf_set2 = pdf_set2.property("checked")
    pdf_set3 = win.findChild(QtCore.QObject, 'pdf_set3')
    pdf_set3 = pdf_set3.property("checked")
    if pdf_set1 == True:
        pdf_set = "meas_type1_uncorrected_PDF"
    elif pdf_set2 == True:
        pdf_set = "meas_type2_corrected_prior_PDF"
    elif pdf_set3 == True:
        pdf_set = "meas_type3_corrected_after_PDF"
    XRD_Analyses = win.findChild(QtCore.QObject, 'XRD_Analyses')
    XRD_Analyses = XRD_Analyses.property("checked")
    filter_type1 = win.findChild(QtCore.QObject, 'filter_type1')
    filter_type1 = filter_type1.property("checked")
    filter_type2 = win.findChild(QtCore.QObject, 'filter_type2')
    filter_type2 = filter_type2.property("checked")
    filter_type3 = win.findChild(QtCore.QObject, 'filter_type3')
    filter_type3 = filter_type3.property("checked")
    filter_degree2 = win.findChild(QtCore.QObject, 'filter_degree2')
    filter_degree2 = filter_degree2.property("checked")
    filter_degree3 = win.findChild(QtCore.QObject, 'filter_degree3')
    filter_degree3 = filter_degree3.property("checked")
    filter_strength = win.findChild(QtCore.QObject, 'textField50')
    filter_strength = filter_strength.property("text")
    baseline_type1 = win.findChild(QtCore.QObject, 'baseline_type1')
    baseline_type1 = baseline_type1.property("checked")
    baseline_type2 = win.findChild(QtCore.QObject, 'baseline_type2')
    baseline_type2 = baseline_type2.property("checked")
    baseline_strength = win.findChild(QtCore.QObject, 'textField51')
    baseline_strength = baseline_strength.property("text")
    temp_signatur = win.findChild(QtCore.QObject, 'temp')
    temp_signatur = temp_signatur.property("text")
    time_signatur = win.findChild(QtCore.QObject, 'time')
    time_signatur = time_signatur.property("text")
    endswith = win.findChild(QtCore.QObject, 'endswith')
    endswith = endswith.property("text")
    metadata_dir = win.findChild(QtCore.QObject, 'metadata_dir')
    metadata_dir = metadata_dir.property("text")
    
    if filter_type1 == True:
        filter_type = None
    if filter_type2 == True:
        filter_type = "whittaker"
    if filter_type3 == True:
        filter_type = "savgol"
    if filter_degree2 == True:
        filter_degree = 2
    if filter_degree3 == True:
        filter_degree = 3
    if baseline_type1 == True:
        baseline_type = None
    if baseline_type2 == True:
        baseline_type = "SNIP"
    
    if slice_bg == '':
        slice_bg = 1    
    if slice_meas == '':
        slice_meas = 1
        
    replacedata = {
            'average': int(AVERAGE),
            'start_temp_meas': float(start_temp_meas),
            'reac_temp_meas': float(reac_temp_meas),
            'Composition': Composition,
            'Qmaxinst': float(Qmaxinst),
            'Qmax': float(Qmax),
            'Qmin': float(Qmin),
            'Rrange': float(Rrange),
            'rpoly': float(rpoly),
            'glass_intens': float(glass_intens),
            'glass_bg_intens': float(glass_bg_intens),
            'FactorMax': float(FactorMax),
            'XRD_slice_bg': float(slice_bg),
            'XRD_slice_meas': float(slice_meas),
            'reference_pack': reference_pack,
            'glass_file': GLASS_MEAS,
            'glass_bg_file': GLASS_BG,
            'Qmaxinst_XRD': float(Qmaxinst_XRD),
            'pdf_set': pdf_set,
            'scan_step': int(scan_step),
            'filter_type': filter_type,
            'filter_strength': int(filter_strength),
            'baseline_type': baseline_type,
            'baseline_strength': int(baseline_strength),
            'filter_degree': int(filter_degree),
            'XRD_Analyses': XRD_Analyses,
            'temp_signatur': temp_signatur,
            'time_signatur': time_signatur,
            'endswith': endswith, 
            'metadata_dir': metadata_dir,
    }
    change_json(replacedata,PROJECTDIR+"/project_params.json")


def BG_XRD_Slice(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=BG_1D_XRD_Slice","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()

def BG_XRD_1D_vs_time(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=BG_1D_XRD_time","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def BG_XRD_2D_vs_time(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=BG_2D_XRD_time","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()


def Meas_XRD_Slice(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=MEAS_1D_XRD_Slice","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()

def Meas_XRD_1D_vs_time(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=MEAS_1D_XRD_time","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def Meas_XRD_2D_vs_time(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=MEAS_2D_XRD_time","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def PDF_create(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=Create_PDF","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def PDF_load(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=PDF","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()

def PDF_1D_time_projected(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=PDF_1D_time_projected","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def PDF_1D_time_overlay(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=PDF_1D_time_overlay","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()
    
def PDF_2D_time_map(win):
    def thread_function(win):
        global AVERAGE
        param_update(win)
        
        subprocess.run(["python", rootdir + "/python_scripts/Eventhandler.py", "--mode=PDF_2D_time_map","--project="+str(PROJECTDIR)],start_new_session=True)    
    
    thread = threading.Thread(target=thread_function,args=(win,))
    thread.start()

class General(QtCore.QObject):
    def __init__(self):
        super().__init__()
        # self.win = win
    def read_file(self):
        print('boood')
        # temp = self.win.findChild(QtCore.QObject, 'temp')
        # temp.setProperty("text", "0.9")

def main():

    app = QtGui.QGuiApplication(sys.argv)
    app.setWindowIcon(QtGui.QIcon(rootdir+"/asset_imports/FlyPDF_icon.ico"))

    engine = QtQml.QQmlApplicationEngine()

    url = QtCore.QUrl.fromLocalFile(rootdir+"/content/App.qml")
    engine.load(url)
    
    win = engine.rootObjects()[0]
    
    #''''''''''''''''' ToolBar ''''''''''''''''''''''''''''''''''''''''''
    save_settings = SaveSettings(win)
    load_settings = LoadSettings(win)
    new_project = NewProject(win)
    load_project = LoadProject(win)
    load_temp_bg = LoadTempBG()
    load_temp_meas = LoadTempMEAS()
    import_reload_bg = LoadReload()
    glass_bg = BGglass()
    glass = MEASglass()
    general = General()
    
    load_background = LoadBackground(win) 
    load_meas = LoadMeasurment(win) 
    
    engine.rootContext().setContextProperty("save_settings", save_settings)
    engine.rootContext().setContextProperty("load_settings", load_settings)
    engine.rootContext().setContextProperty("new_project", new_project)
    engine.rootContext().setContextProperty("load_project", load_project)
    engine.rootContext().setContextProperty("load_background", load_background)
    engine.rootContext().setContextProperty("load_meas", load_meas)
    engine.rootContext().setContextProperty("load_bgtemp", load_temp_bg)
    engine.rootContext().setContextProperty("load_meastemp", load_temp_meas)
    engine.rootContext().setContextProperty("import_reload_bg", import_reload_bg)
    engine.rootContext().setContextProperty("load_bgglass", glass_bg)
    engine.rootContext().setContextProperty("load_glass", glass)
    engine.rootContext().setContextProperty("text_change", general)
    
    
    #''''''''''''''''' Plot / Generate Buttons ''''''''''''''''''''''''''''''''''''''''''
    button = win.findChild(QtCore.QObject, '1D_vs_time')
    button.clicked.connect(lambda: BG_XRD_1D_vs_time(win)) 
    
    button = win.findChild(QtCore.QObject, '2D_vs_time')
    button.clicked.connect(lambda: BG_XRD_2D_vs_time(win)) 
    
    button = win.findChild(QtCore.QObject, '1D_slice')
    button.clicked.connect(lambda: BG_XRD_Slice(win)) 
    
    button = win.findChild(QtCore.QObject, 'XRD_1D_vs_time_meas')
    button.clicked.connect(lambda: Meas_XRD_1D_vs_time(win)) 
    
    button = win.findChild(QtCore.QObject, 'XRD_2D_vs_time_meas')
    button.clicked.connect(lambda: Meas_XRD_2D_vs_time(win)) 
    
    button = win.findChild(QtCore.QObject, 'XRD_1D_vs_ref_meas')
    button.clicked.connect(lambda: Meas_XRD_Slice(win)) 
    
    button = win.findChild(QtCore.QObject, 'create_pdf')
    button.clicked.connect(lambda: PDF_create(win)) 
    
    button = win.findChild(QtCore.QObject, 'PDF_load')
    button.clicked.connect(lambda: PDF_load(win)) 
    
    button = win.findChild(QtCore.QObject, 'PDF_1D_projected')
    button.clicked.connect(lambda: PDF_1D_time_projected(win)) 

    button = win.findChild(QtCore.QObject, 'PDF_1D_overlay')
    button.clicked.connect(lambda: PDF_1D_time_overlay(win)) 

    button = win.findChild(QtCore.QObject, 'PDF_2D_map')
    button.clicked.connect(lambda: PDF_2D_time_map(win)) 
    
    #''''''''''''''''' Load Buttons ''''''''''''''''''''''''''''''''''''''''''
    
    
    
    
    #''''''''''''''''' Init values ''''''''''''''''''''''''''''''''''''''''''
    filename = rootdir + "/default_params.json"
    params = open_json(filename)
    start_temp_meas_obj = win.findChild(QtCore.QObject, 'textField18')
    start_temp_meas_obj.setProperty("text",params["start_temp_meas"])
    reac_temp_meas_obj = win.findChild(QtCore.QObject, 'textField19')
    reac_temp_meas_obj.setProperty("text",params["reac_temp_meas"])
    Qmaxinst_obj = win.findChild(QtCore.QObject, 'textField11')
    Qmaxinst_obj.setProperty("text",params["Qmaxinst"])
    Qmin_obj = win.findChild(QtCore.QObject, 'textField12')
    Qmin_obj.setProperty("text",params["Qmin"])
    Qmax_obj = win.findChild(QtCore.QObject, 'textField13')
    Qmax_obj.setProperty("text", params["Qmax"])
    Rrange_obj = win.findChild(QtCore.QObject, 'textField14')
    Rrange_obj.setProperty("text",params["Rrange"])
    rpoly_obj = win.findChild(QtCore.QObject, 'textField15')
    rpoly_obj.setProperty("text",params["rpoly"])
    glass_intens = win.findChild(QtCore.QObject, 'textField21')
    glass_intens.setProperty("text",params["glass_intens"])
    glass_bg_intens = win.findChild(QtCore.QObject, 'textField46')
    glass_bg_intens.setProperty("text",params["glass_bg_intens"])
    average = win.findChild(QtCore.QObject, 'textField48')
    average = average.setProperty("text",params["average"])
    temp_signatur = win.findChild(QtCore.QObject, 'temp')
    temp_signatur = temp_signatur.setProperty("text",params['temp_signatur'])
    time_signatur = win.findChild(QtCore.QObject, 'time')
    time_signatur = time_signatur.setProperty("text",params['time_signatur'])
    endswith = win.findChild(QtCore.QObject, 'endswith')
    endswith = endswith.setProperty("text",params['endswith'])
    metadata_dir = win.findChild(QtCore.QObject, 'metadata_dir')
    metadata_dir = metadata_dir.setProperty("text",params['metadata_dir']) #you might want to set this to the users raw data folder
    pane1 = win.findChild(QtCore.QObject, 'pane1')
    pane1.setProperty("visible", "false")


   
    def on_object_created(obj, objUrl):
        if obj is None and url == objUrl:
            QtCore.QCoreApplication.exit(-1)
            

    engine.objectCreated.connect(on_object_created, QtCore.Qt.ConnectionType.QueuedConnection)   
     
    sys.exit(app.exec())
    


if __name__ == "__main__":
    main()
    

