import sys, getopt
from PDF_generator_just_BG_class import LOADBG 
from PDF_generator_classbase import LOADMEAS
from PDF_plotter_insitu_class import LOADPDF
import json
import pathlib

def open_json(filename):
    with open(filename,"r+") as file:
        file_data = json.load(file)
        params = file_data["parameters"][0]
    return params

def main(argv):
    XRD_Analyses = False
    opts, args = getopt.getopt(argv,'m:p:',['mode=','project='])
    for opt, arg in opts:
        if opt in ('-m','--mode'):
            mode = arg
        if opt in ('-p','--project'):
            project = arg
            
    params = open_json(project+"/project_params.json")
    
    if 'BG' in mode:
        Reload = pathlib.Path(project + '/processed/Reload_files/bg_Reload/' + params['sampleName_bg'] + '.mat')
        if Reload.is_file():
            print('Starting from Reload')
            Reload = Reload
        else: 
            Reload = None

        if mode == "BG_1D_XRD_Slice":
            bg = LOADBG(projectPath=project,path=None,average=params['average'],tempPath=None,sampleName=params['sampleName_bg'],bg_glass=params['glass_bg_file'],empty_glass_int=params['glass_bg_intens'], Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            bg.plot_1D_XRD_Slice(int(params['XRD_slice_bg']))
            
        if mode == "BG_1D_XRD_time":
            bg = LOADBG(projectPath=project,path=None,average=params['average'],tempPath=None,sampleName=params['sampleName_bg'],bg_glass=params['glass_bg_file'],empty_glass_int=params['glass_bg_intens'],Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            bg.plot_1D_XRD_vs_time()
        
        if mode == "BG_2D_XRD_time":
            bg = LOADBG(projectPath=project,path=None,average=params['average'],tempPath=None,sampleName=params['sampleName_bg'],bg_glass=params['glass_bg_file'],empty_glass_int=params['glass_bg_intens'],Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            bg.plot_2D_XRD_vs_time()
            
            
    if 'MEAS' in mode:
        Reload = pathlib.Path(project + '/processed/Reload_files/meas_Reload/' + params['sampleName'] + '.mat')
        if Reload.is_file():
            print('Starting from Reload')
            Reload = Reload
        else: 
            Reload = None

        if mode == "MEAS_1D_XRD_Slice":
            meas = LOADMEAS(projectPath=project,path=None,ramp_start_temp=params['start_temp_meas'],plato_start_temp=params['reac_temp_meas'],average=params['average'],tempPath=None,sampleName=params['sampleName'],bg_sampleName=params['sampleName_bg'],glass=params['glass_file'],glass_intens=params['glass_intens'], Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, references=params['reference_pack'], FactorMax=params["FactorMax"], temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            if params['XRD_Analyses'] == True:
                meas.filter_and_baseline(filter=params['filter_type'],filter_degree=params['filter_degree'],filter_strenght=params['filter_strength'],baseline_strength=params['baseline_strength'],baseline_type=params['baseline_type'],xrd_save_type=None)
            meas.plot_1D_XRD_Slice(int(params['XRD_slice_meas']))
            
        if mode == "MEAS_1D_XRD_time":
            meas = LOADMEAS(projectPath=project,path=None,ramp_start_temp=params['start_temp_meas'],plato_start_temp=params['reac_temp_meas'],average=params['average'],tempPath=None,sampleName=params['sampleName'],bg_sampleName=params['sampleName_bg'],glass=params['glass_file'],glass_intens=params['glass_intens'],Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, FactorMax=params["FactorMax"], temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            if params['XRD_Analyses'] == True:
                meas.filter_and_baseline(filter=params['filter_type'],filter_degree=params['filter_degree'],filter_strenght=params['filter_strength'],baseline_strength=params['baseline_strength'],baseline_type=params['baseline_type'],xrd_save_type=None)
            meas.plot_1D_XRD_vs_time()
        
        if mode == "MEAS_2D_XRD_time":
            meas = bg = LOADMEAS(projectPath=project,path=None,ramp_start_temp=params['start_temp_meas'],plato_start_temp=params['reac_temp_meas'],average=params['average'],tempPath=None,sampleName=params['sampleName'],bg_sampleName=params['sampleName_bg'],glass=params['glass_file'],glass_intens=params['glass_intens'],Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, FactorMax=params["FactorMax"], temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
            if params['XRD_Analyses'] == True:
                meas.filter_and_baseline(filter=params['filter_type'],filter_degree=params['filter_degree'],filter_strenght=params['filter_strength'],baseline_strength=params['baseline_strength'],baseline_type=params['baseline_type'],xrd_save_type=None)
            meas.plot_2D_XRD_vs_time()
      
    if mode == 'XRD_Analyses':
        meas = LOADMEAS(projectPath=project,path=None,ramp_start_temp=params['start_temp_meas'],plato_start_temp=params['reac_temp_meas'],average=params['average'],tempPath=None,sampleName=params['sampleName'],bg_sampleName=params['sampleName_bg'],glass=params['glass_file'],glass_intens=params['glass_intens'],Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, FactorMax=params["FactorMax"], temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
        meas.filter_and_baseline(filter=params['filter_type'],filter_degree=params['filter_degree'],filter_strenght=params['filter_strength'],baseline_strength=params['baseline_strength'],baseline_type=params['baseline_type'],xrd_save_type="mat")
            
    if mode == 'Create_PDF':
        Reload = pathlib.Path(project + '/processed/Reload_files/meas_Reload/' + params['sampleName'] + '.mat')
        if Reload.is_file():
            print('Starting from Reload')
            Reload = Reload
        else: 
            Reload = None
        
        meas = LOADMEAS(projectPath=project,path=None,ramp_start_temp=params['start_temp_meas'],plato_start_temp=params['reac_temp_meas'],average=params['average'],tempPath=None,sampleName=params['sampleName'],bg_sampleName=params['sampleName_bg'],glass=params['glass_file'],glass_intens=params['glass_intens'], Qmaxinst_XRD=params['Qmaxinst_XRD'],reload=Reload, mode=mode, references=params['reference_pack'], FactorMax=params["FactorMax"], temp_signatur=params['temp_signatur'],time_signatur=params['time_signatur'], endswith=params['endswith'],metadata_dir=params['metadata_dir'])
        meas.create_pdf(Composition=params['Composition'],Qmaxinst=params['Qmaxinst'],Qmax=params['Qmax'],Qmin=params['Qmin'],Rmax=params['Rrange'],Rpoly=params['rpoly'])
        
    if 'PDF' in mode:  
        pdf = LOADPDF(projectPath=project,startScan=params['start_scan_PDF'],endScan=params['end_scan_PDF'],scanStep=params['scan_step'],average=params['average'],sampleName=params['sampleName'], mode=params['pdf_set'])
        
        print(mode)
        if mode == "PDF_1D_time_projected":
            pdf.plot_1D_projected()
            
        if mode == "PDF_1D_time_overlay":
            pdf.plot_1D_vs_time()
            
        if mode == "PDF_2D_time_map":
            pdf.plot_2D_vs_time()
        
        
if __name__ == '__main__':
    main(sys.argv[1:])
    